<?php

/*
Plugin Name: Image Crosspost
Plugin URI:http://www.pivari.com/wordpress-plugins/image-crosspost-wp-plugin/
Description: Crosspost images in a published post via email
Version: 1.2.0
Author: Fabrizio Pivari
Author URI: http://www.pivari.com
 */
/*  Copyright 2012 Fabrizio Pivari  (email : fabrizio@pivari.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$imagecrosspostversion="1.2.0";

if (!defined('WP_CONTENT_URL'))
      define('WP_CONTENT_URL', get_option('siteurl').'/wp-content');
if (!defined('WP_CONTENT_DIR'))
      define('WP_CONTENT_DIR', ABSPATH.'wp-content');
if (!defined('WP_PLUGIN_URL'))
      define('WP_PLUGIN_URL', WP_CONTENT_URL.'/plugins');
if (!defined('WP_PLUGIN_DIR'))
      define('WP_PLUGIN_DIR', WP_CONTENT_DIR.'/plugins');

function activate_imagecrosspost() {
	add_option('fromname', get_settings('blogname'));
	add_option('fromemail', get_option('admin_email'));
	add_option('flickremail', '');
	add_option('flickrprivacy', 'public');
//	add_option('userid', '');
//	add_option('signature', '');
}

function deactive_imagecrosspost() {
  delete_option('fromname');
  delete_option('fromemail');
  delete_option('flickremail');
  delete_option('flickrprivacy');
//  delete_option('userid');
//  delete_option('signature');
}

function admin_init_imagecrosspost() {
  register_setting('imagecrosspost', 'fromname');
  register_setting('imagecrosspost', 'fromemail');
  register_setting('imagecrosspost', 'flickremail');
  register_setting('imagecrosspost', 'flickrprivacy');
//  register_setting('imagecrosspost', 'userid');
//  register_setting('imagecrosspost', 'signature');
}

function admin_menu_imagecrosspost() {
  add_options_page('Imagecrosspost', 'Imagecrosspost', 8, 'imagecrosspost', 'options_page_imagecrosspost');
}

function options_page_imagecrosspost() {
  include(WP_PLUGIN_DIR.'/image-crosspost/options.php');  
}

function imagecrosspost( $post_ID )  
{
   $post = get_post($post_ID);
   global $crosspostversion;
   $fromname = get_option('fromname');
   $fromemail = get_option('fromemail');
   $flickremail = get_option('flickremail');
   $flickrprivacy = get_option('flickrprivacy');
   if ($fromname) {$mailfrom_name=$fromname;}
   if ($fromemail) {$mailfrom_email=$fromemail;}
   if ($flickremail) {$friends=$flickremail;}
   if($flickrprivacy != 'public') {
      $fprivacy = "+".$flickrprivacy."@";
      $friends = str_replace("@", $fprivacy, $friends);
      }
   $post_title = $post->post_title;
   $post_content = $post->post_content;
   
   // post tags into Flickr tags
   $tag_list = wp_get_post_tags( $post->ID, array( 'fields' => 'names' ) );
   $tags = "tags: ";
   for ($i = 0; $i < count($tag_list)-1; $i++) {
      $tags .= "\"" . $tag_list[$i] . "\", ";
   }
   $tags .= "\"" . $tag_list[count($tag_list)-1] . "\"";
   if ($i > 0) {$tag_true=1;}

   $siteurl=get_option('siteurl');

// find image tags
   preg_match_all('/<img[^>]+>/i',$post_content, $rawimagearray,PREG_SET_ORDER); 
// put image tags in a simpler array
   $imagearray = array();
   for ($i = 0; $i < count($rawimagearray); $i++) {
      array_push($imagearray, $rawimagearray[$i][0]);
      }

// put image attributes in another array
   $imageinfo = array();
   foreach($imagearray as $img_tag) {
      preg_match_all('/(src|alt|title)=("[^"]*")/i',$img_tag, $imageinfo[$img_tag]);
      }

   $headers = "";
   $headers = "From: ". $mailfrom_name . " <" . $mailfrom_email . ">\r\n";
   $headers .= "X-Mailer: Crosspost by Fabrizio Pivari\r\n";
   $headers .= "MIME-Version: 1.0\r\n";
   $headers .= "Content-Type: text/html; charset=\"utf-8\"\r\n";    
   $headers .= "Content-Transfer-Encoding: 7bit\r\n";

// combine everything into one array
// src $imageinfo[$img_tag][2][0]);
// alt $imageinfo[$img_tag][2][1]);
// title $imageinfo[$img_tag][2][2]);
   $email_content="";
   $AllImageInfo = array();
   foreach($imagearray as $img_tag) {
      $imgsrc=str_replace("\"", "", $imageinfo[$img_tag][2][0]);
      $imgalt=str_replace("\"", "", $imageinfo[$img_tag][2][1]);
      $imgtitle=str_replace("\"", "", $imageinfo[$img_tag][2][2]);
      if($imgalt) {$email_title=$imgalt;} else {$email_title=$post_title;}
      if($imgtitle) {
         $email_body=$imgtitle;
         if($tag_true=1) {$email_body.="<br /><br />\n".$tags;}
      } else {$email_body=$post_title;}
// verify the url of the image is of the local host
      if (preg_match("/http/", $imgsrc)) {
	 if (stripos($imgsrc,$siteurl) !== false)
  	    {$imagepath  = str_replace($siteurl, "", $imgsrc);
	    $attachment = ABSPATH . $imagepath;
            wp_mail( $friends, $email_title, $email_body, $headers, $attachment);
	    }
         } else {
// relative url
         $attachment = ABSPATH . $imgsrc;
         wp_mail( $friends, $email_title, $email_body, $headers, $attachment);
         }
      }
   return $post_ID;
}

function imagecrosspost_settings( $links ) {
	$settings_link = '<a href="options-general.php?page=imagecrosspost">'.__('Settings').'</a>';
	array_unshift( $links, $settings_link );
	return $links;
}

function imagecrosspost_plugin_settings($links, $file) {
	if ( $file == basename( dirname( __FILE__ ) ).'/'.basename( __FILE__ ) ) {
		$links[] = '<a href="options-general.php?page=imagecrosspost">' . __('Settings') . '</a>';
		$links[] = '<a href="http://www.pivari.com/contatta-pivari/">' . __('Support') . '</a>';
	}
	return $links;
}

register_activation_hook(__FILE__, 'activate_imagecrosspost');
register_deactivation_hook(__FILE__, 'deactive_imagecrosspost');
add_action('admin_init', 'admin_init_imagecrosspost');
add_action('admin_menu', 'admin_menu_imagecrosspost');
add_action('plugin_action_links_'.basename( dirname( __FILE__ ) ).'/'.basename( __FILE__ ), 'imagecrosspost_settings', 10, 4 );
add_filter('plugin_row_meta', 'imagecrosspost_plugin_settings', 10, 2 );

add_action('publish_post', 'imagecrosspost');

?>
